(function (Drupal, drupalSettings, once) {
  'use strict';

  Drupal.behaviors.keySave = {
    attach: function (context, settings) {
      // Identify the primary submit button based on its data attribute.
      const save_btn = document.querySelector('[data-drupal-selector="edit-submit"]');
      // Add event listener on keydown
      document.addEventListener('keydown', (event) => {
        // Trigger the save and prevent browser default behaviour (save dialog).
        if ((event.ctrlKey || event.metaKey) && event.code == 'KeyS') {
          save_btn.click();
          event.preventDefault();
        }
      }, false);

      Drupal.keySaveCKEditor.init(context);
    }
  };

  Drupal.keySaveCKEditor = {
    init: (context) => {
      once('keySaveCKEditors', 'body', context).forEach(() => {
        if (window.CKEDITOR && CKEDITOR !== undefined) {
          CKEDITOR.on('instanceReady', (element) => {
            const save_btn = document.querySelector('[data-drupal-selector="edit-submit"]');

            element.editor.on('key', function (event) {
              if (event.data.keyCode == CKEDITOR.CTRL + 83 || event.data.keyCode == 1114195) {
                save_btn.click();
                event.cancel();
              }
            });
          });
        }
      });
    }
  };

} (Drupal, drupalSettings, once));
